<template>
    <v-list nav rounded>
        <template v-for="item in items">
            <v-list-group
                v-if="item.hasOwnProperty('children')"
                :key="item.text"
            >
                <template v-slot:activator>
                    <v-list-item-action>
                        <v-icon :color="item.color ? item.color: 'primary' ">{{ item.icon }}</v-icon>
                    </v-list-item-action>

                    <v-list-item-content>
                        <v-list-item-title class="default--text">
                            {{ item.text }}
                        </v-list-item-title>
                    </v-list-item-content>
                </template>

                <v-list-item
                    v-for="subItem in item.children"
                    :key="subItem.text"
                    :to="subItem.to"
                >
                    <v-list-item-action>
                        <v-icon :color="subItem.color ? subItem.color: 'primary' ">{{ subItem.icon }}</v-icon>
                    </v-list-item-action>

                    <v-list-item-content>
                        <v-list-item-title class="default--text">
                            {{ subItem.text }}
                        </v-list-item-title>
                    </v-list-item-content>
                </v-list-item>
            </v-list-group>

            <v-list-item
                v-else-if="can(item.permission)"
                :key="item.to"
                :to="item.to"
            >
                <v-list-item-action>
                    <v-icon :color="item.color ? item.color: 'primary' ">{{ item.icon }}</v-icon>
                </v-list-item-action>
                <v-list-item-content>
                    <v-list-item-title class="default--text">
                            <v-badge
                                v-if="item.quantity != null"
                                color="red"
                            >
                                <span slot="badge">{{item.quantity}}</span>
                                {{ item.text }}
                            </v-badge>
                        {{ item.quantity == undefined ? item.text : ""}}
                    </v-list-item-title>
                </v-list-item-content>
            </v-list-item>
        </template>
    </v-list>
</template>

<script>
    import permission from "../../../mixins/permission";
    import {mapGetters, mapMutations} from "vuex";

    export default {
        name: 'NavMenu',
        mixins: [permission],
        data: () =>({
            pendingOrderCount : 0,
            pendingPickCount: 0
        }),
        computed: {
            items() {
                return [
                    {
                        icon: 'mdi-view-dashboard',
                        text: this.$t('dashboard'),
                        to: '/',
                        permission: 'dashboard.access'
                    },
                    {
                        icon: 'mdi-account-multiple-plus',
                        text: this.$t('account'),
                        color: 'yellow accent-4',
                        to: '/account',
                        permission: 'account.view'
                    },
                    {
                        icon: 'mdi-text-box',
                        text: this.$tc('pick', 2),
                        color: 'pink accent-3',
                        to: '/pick',
                        quantity: this.pendingPickCount,
                        permission: 'order.view'
                    },
                    {
                        icon: 'mdi-cart',
                        text: this.$tc('order', 2),
                        color: 'pink accent-3',
                        to: '/order',
                        quantity: this.pendingOrderCount,
                        permission: 'order.view'
                    },
                    {
                        icon: 'mdi-store',
                        text: this.$t('store'),
                        color: 'teal accent-4',
                        permission: 'product.view',
                        children: [
                            { text: this.$tc('collection', 2), to: '/collection' },
                            { text: this.$tc('category', 2), to: '/category' },
                            { text: this.$t('vendor'), to: '/vendor' },
                            { text: this.$tc('brand', 2), to: '/brand' },
                            { text: this.$t('variant'), to: '/variant' },
                            { text: this.$t('product'), to: '/product' },
                        ]
                    },
                    {
                        icon: 'mdi-warehouse',
                        text: this.$t('inventory'),
                        color: 'orange darken-4',
                        permission: 'product.view',
                        children: [
                            { text: this.$t('warehouse'), to: '/warehouse' },
                            { text: this.$t('items'), to: '/items' }
                        ]
                    },
                    {
                        icon: 'mdi-shopping',
                        text: this.$t('wishlist'),
                        color: 'red darken-4',
                        permission: 'product.view',
                        to : '/wishlist'
                    },
                    {
                        icon: 'mdi-book-open',
                        text: this.$t('plan'),
                        color: 'purple darken-4',
                        to: '/plans',
                        permission: 'plan.view'
                    },
                    {
                        icon: 'mdi-ticket-percent',
                        text: this.$tc('coupon', 2),
                        color: 'purple accent-3',
                        to: '/coupons',
                        permission: 'system.editor'
                    },
                    {
                        icon: 'mdi-image',
                        text: this.$t('banner'),
                        color: 'cyan darken-4',
                        to: '/banner',
                        permission: 'banner.create'
                    },
                    {
                        icon: 'mdi-file-document',
                        text: this.$tc('report',2),
                        color: 'orange darken-4',
                        permission: 'product.view',
                        children: [
                            { text: this.$tc('subscription',2), to: '/subscriptions' },
                            { text: this.$t('revenue'), to: '/revenue' }
                        ]
                    },
                    {
                        icon: 'mdi-calendar-clock',
                        text: this.$tc('timeslot', 2),
                        color: 'blue accent-4',
                        to: '/timeslots',
                        permission: 'system.editor'
                    },
                    {
                        icon: 'mdi-calendar-month-outline',
                        text: this.$t('holiday'),
                        color: 'pink darken-1',
                        to: '/holidays',
                        permission: 'system.editor'
                    }
                ]
            }
        },
        methods: {
            fetchPendingOrderCount(){
                return new Promise((resolve, reject) => {
                    axios.get(`api/orders/pending`)
                        .then(({ data }) => {
                            resolve(data);
                        })
                        .catch(error => {
                            reject(error);
                        })
                })
            },
            mapPendingOrderCount(order){
                this.pendingOrderCount = order.pending_order_count;
            },
            fetchPendingPickCount(){
                return new Promise((resolve, reject) => {
                    axios.get(`api/picks/pending`)
                        .then(({ data }) => {
                            resolve(data);
                        })
                        .catch(error => {
                            reject(error);
                        })
                })
            },
            mapPendingPickCount(pick){
                this.pendingPickCount = pick.pending_pick_count;
            },
        },
        mounted() {
            this.fetchPendingOrderCount()
                .then(data => {
                    this.mapPendingOrderCount(data);
                })
            this.fetchPendingPickCount()
                .then(data => {
                    this.mapPendingPickCount(data);
                })
        },

    }
</script>

<style scoped>
</style>
